import {Component, EventEmitter, Input, Output} from '@angular/core';
import {GameModel} from "../../game-model/GameModel";
import {Gamesystem} from "../../game-model/gamesystems/Gamesystem";
import {State} from "../../game-model/gamesystems/State";
import {Transition} from "../../game-model/gamesystems/Transition";
import {SimpleGamesystem} from "../../game-model/gamesystems/SimpleGamesystem";
import {ProductGamesystem} from "../../game-model/gamesystems/ProductGamesystem";

@Component({
  selector: 'app-gamesystem-editor',
  templateUrl: './gamesystem-editor.component.html',
  styleUrl: './gamesystem-editor.component.scss'
})
export class GamesystemEditorComponent {

  @Input() gamesystem: Gamesystem<State<any>, Transition<any>> | undefined
  @Output('onOpenGamesystemEditor') openGamesystemEmitter = new EventEmitter<SimpleGamesystem>();

  isSimpleGamesystem() {
    return this.gamesystem instanceof SimpleGamesystem;
  }

  convertGamesystemToSimpleGamesystem() {
    if(this.gamesystem instanceof SimpleGamesystem) {
      return this.gamesystem as SimpleGamesystem;
    }
  }

  convertGamesystemToProductGamesystem() {
    if(this.gamesystem instanceof ProductGamesystem) {
      return this.gamesystem as ProductGamesystem;
    }
  }

  onOpenGamesystemEditor(gamesystem: SimpleGamesystem) {
    this.openGamesystemEmitter.emit(gamesystem);
  }
}
